'use strict';

const babel = require('@babel/core');
const glob = require('fast-glob');
const path = require('node:path');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e.default : e; }

const babel__default = /*#__PURE__*/_interopDefaultCompat(babel);
const glob__default = /*#__PURE__*/_interopDefaultCompat(glob);
const path__default = /*#__PURE__*/_interopDefaultCompat(path);

const plugin = (options) => {
  const { src, ignore, compilerOptions } = { ...options };
  if (!src) {
    throw new Error("The `src` option is required");
  }
  return async (context) => {
    const files = await glob__default(src, {
      ignore: ignore ?? [],
      cwd: context.src
    });
    await Promise.all(
      files.map((file) => {
        const filePath = path__default.join(context.src, file);
        return babel__default.transformAsync(filePath, compilerOptions);
      })
    );
  };
};

module.exports = plugin;
